
#include "iic.h"
#include "debug.h"

/*  */
extern uint8_t  Buffer_Rx[];
extern uint8_t  Rx_Idx;
extern uint8_t  Flag_RcvOK;

void I2C1_EV_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

void I2C_GPIO_Configuration(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;
    I2C_InitTypeDef   I2C_InitStructure;
    NVIC_InitTypeDef  NVIC_InitStructure;

    /* ʹAPB2ʱ */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
    /* ʹAPB1ʱ */
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1, ENABLE);

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_OD;
  GPIO_Init(GPIOB, &GPIO_InitStructure);

    I2C_DeInit(I2C1);                                                  //λI2C
  I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;                         //I2Cģʽ
  I2C_InitStructure.I2C_DutyCycle = I2C_DutyCycle_2;                 //ռձ(ģʽʱ)
  I2C_InitStructure.I2C_OwnAddress1 = RX_ADDRESS;                   //豸ַ
  I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;                        //Ӧ
  I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
  I2C_InitStructure.I2C_ClockSpeed = I2C_SPEED;                      //ٶ
  I2C_Init(I2C1, &I2C_InitStructure);

    /* ȼ */
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
  /* ж */
  NVIC_InitStructure.NVIC_IRQChannel = I2C1_EV_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;          //ȼ
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;                 //ȼ
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  NVIC_InitStructure.NVIC_IRQChannel = I2C1_ER_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;                 //ȼ
  NVIC_Init(&NVIC_InitStructure);

  I2C_ITConfig(I2C1, I2C_IT_BUF | I2C_IT_EVT, ENABLE);               //ʹж

  I2C_Cmd(I2C1, ENABLE);                                             //ʹI2C
  printf("1111\r\n");
}


/************************************************
  I2C1_EV_IRQHandler
      I2C1¼ж
      
  ֵ  
      strongerHuang
*************************************************/
void I2C1_EV_IRQHandler(void)
{

  __IO uint32_t SR1Register =0;
  __IO uint32_t SR2Register =0;

  SR1Register = I2C1->STAR1;                       //ȡ״̬
  SR2Register = I2C1->STAR2;

  /* I2C1Ǵӻ(MSL = 0) */
  if((SR2Register &0x0001) != 0x0001)
  {
    /* ѷַ(ADDR = 1: EV1) */
    if((SR1Register & 0x0002) == 0x0002)
    {
      /* ־׼ */
      SR1Register = 0;
      SR2Register = 0;

      Rx_Idx = 0;
    }

    /* (RXNE = 1: EV2) */
    if((SR1Register & 0x0040) == 0x0040)
    {
      Buffer_Rx[Rx_Idx++] = I2C1->DATAR;
      SR1Register = 0;
      SR2Register = 0;
    }

    /* ⵽ֹͣ(STOPF =1: EV4) */
    if(( SR1Register & 0x0010) == 0x0010)
    {
      I2C1->CTLR1 |= 0x0001;
      SR1Register = 0;
      SR2Register = 0;

      Flag_RcvOK = 1;                            //OKʶ
    }
  }
 // printf("2222\r\n");
}

